#include "helper.h"

#include <iostream>
#include <cstdlib>
#include "rose.h"

#include "../internal_representation/design.h"

void
risc::inst::fix_static_cast_issue()
{
  std::cout << "RISC: patching ROSE limitations..." << std::endl;

  SgProject *project = risc::get_project();
  char SysCmd[300];

  for(int i = 0; i < project->numberOfFiles(); i++) {
    sprintf(SysCmd, "sed -r -i \'s/create_method_process\\s*\\((.*)\\,(.*)\\,(.*)\\,(.*)\\,(.*)\\,(.*)\\,(.*)\\)/create_method_process (\\1, \\2, static_cast<sc_core::SC_ENTRY_FUNC>(\\3), \\4, \\5, \\6, \\7)/\' rose_%s", (*project)[i]->get_sourceFileNameWithoutPath().c_str());

    std::cout << "  " << SysCmd << std::endl;

    if(system(SysCmd) != 0) {
      std::cout << "\nERROR: Patch File ";
      std::cout << (*project)[i]->get_sourceFileNameWithoutPath();
      std::cout << "failed" << std::endl;
      exit(1);
    }

    sprintf(SysCmd, "sed -r -i \'s/create_thread_process\\s*\\((.*)\\,(.*)\\,(.*)\\,(.*)\\,(.*)\\,(.*)\\,(.*)\\)/create_thread_process (\\1, \\2, static_cast<sc_core::SC_ENTRY_FUNC>(\\3), \\4, \\5, \\6, \\7)/\' rose_%s", (*project)[i]->get_sourceFileNameWithoutPath().c_str());

    std::cout << "  " << SysCmd << std::endl;

    if(system(SysCmd) != 0) {
      std::cout << "\nERROR: Patch File ";
      std::cout << (*project)[i]->get_sourceFileNameWithoutPath();
      std::cout << "failed" << std::endl;
      exit(1);
    }

    sprintf(SysCmd, "sed -r -i \'s/create_cthread_process\\s*\\((.*)\\,(.*)\\,(.*)\\,(.*)\\,(.*)\\,(.*)\\,(.*)\\)/create_cthread_process (\\1, \\2, static_cast<sc_core::SC_ENTRY_FUNC>(\\3), \\4, \\5, \\6, \\7)/\' rose_%s", (*project)[i]->get_sourceFileNameWithoutPath().c_str());

    std::cout << "  " << SysCmd << std::endl;

    if(system(SysCmd) != 0) {
      std::cout << "\nERROR: Patch File ";
      std::cout << (*project)[i]->get_sourceFileNameWithoutPath();
      std::cout << "failed" << std::endl;
      exit(1);
    }
  }
}
