#ifndef EVENT_AND_LIST_H_INCLUDED_
#define EVENT_AND_LIST_H_INCLUDED_

#include <vector>

#include "rose.h"

#include "object.h"

namespace risc {

class EventAndList: public Object {

public:

  /**
   * \brief default constructor
   */
  explicit EventAndList(SgVariableDefinition *ast_node);

  /**
   * \brief Get function for the name of the ast type of the event
   * \return Name as std::string
   */
  virtual std::string get_ast_type_name();

private:
  /**
   * \brief Disabled copy constructor
   */
  EventAndList(const EventAndList &e);
};

typedef std::vector<EventAndList*> EventAndListVector;
typedef std::vector<EventAndList*>::iterator EventAndListVectorIter;
typedef std::vector<EventAndList*>::const_iterator EventAndListVectorConstIter;

}; // end namespace risc

#endif /* EVENT_AND_LIST_H_INCLUDED_ */
