#include "variable.h"

#include "../tools/variable_helper.h"

risc::Variable::Variable(SgVariableDefinition *ast_node):
  Object(ast_node, VariableType)
{ }

std::string
risc::Variable::get_ast_type_name()
{
  SgPointerType *pointer_type = isSgPointerType(ast_type_pointer_);
  if(pointer_type) {
    return pointer_type->get_base_type()->unparseToString();

  } else {
    return ast_type_pointer_->unparseToString();
  }
}

bool risc::Variable::is_reference()
{
  return tools::is_reference_variable(
            isSgVariableSymbol(
                get_ast_node()->get_declaration()->get_decl_item(0)
                  ->search_for_symbol_from_symbol_table()));
}

bool risc::Variable::is_static()
{
  return tools::is_static_variable(
            isSgVariableSymbol(
                get_ast_node()->get_declaration()->get_decl_item(0)
                  ->search_for_symbol_from_symbol_table()));
}

bool risc::Variable::is_pointer()
{
  return tools::is_pointer_variable(
            isSgVariableSymbol(
                get_ast_node()->get_declaration()->get_decl_item(0)
                  ->search_for_symbol_from_symbol_table()));
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
