#include "systemc.h"

class ChannelInterface: virtual public sc_interface
{
public:
  virtual void func() = 0;
};

class Channel:
  public sc_channel,
  public ChannelInterface {

public:
  Channel(sc_module_name name):
    sc_channel(name)
  { }

  sc_event event;

  void func()
  {
    int before;
    wait(SC_ZERO_TIME);
    int middle;
    wait(SC_ZERO_TIME);
    int after;
  }

};

class Module: public sc_module {
public:

  SC_HAS_PROCESS(Module);
  sc_port<ChannelInterface> port_i;

  Module(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);
    SC_THREAD(thread4);
  }

  void thread1()
  {
    int a,b;

    while(true) {
      int i = 3;
      switch(i) {
        case 1:
        {
          port_i->func();
          break;
        }
        case 2:
        {
          port_i->func();
          break;
        }
      }
    }
    int final_stmt;
  }

  void thread2()
  {
    int a,b;

    while(true) {
      int i = 3;
      switch(i) {
        case 1:
        {
          int FUNCTION_CALLA;
          int Abefore;
          wait(SC_ZERO_TIME);
          int Amiddle;
          wait(SC_ZERO_TIME);
          int Aafter;
          break;
        }
        case 2:
        {
          int FUNCTION_CALLB;
          int Bbefore;
          wait(SC_ZERO_TIME);
          int Bmiddle;
          wait(SC_ZERO_TIME);
          int Bafter;
          break;
        }
      }
    }
    int final_stmt;
  }

  void thread3()
  {
    int a,b;

    while(true) {
      int i = 3;
      switch(i) {
        case 1:
        {
          port_i->func();
        }
        case 2:
        {
          port_i->func();
        }
      }
    }
    int final_stmt;
  }

  void thread4()
  {
    int a,b;

    while(true) {
      int i = 3;
      switch(i) {
        case 1:
        {

          int FUNCTION_CALLA;
          int Abefore;
          wait(SC_ZERO_TIME);
          int Amiddle;
          wait(SC_ZERO_TIME);
          int Aafter;
        }
        case 2:
        {
          int FUNCTION_CALLB;
          int Bbefore;
          wait(SC_ZERO_TIME);
          int Bmiddle;
          wait(SC_ZERO_TIME);
          int Bafter;
        }
      }
    }
    int final_stmt;
  }
};

class Top: public sc_module {
public:

  Top(sc_module_name mn):
    sc_module(mn),
    m("m"),
    c("c")
  { }

  Channel c;
  Module m;

  void before_end_of_elaboration()
  {
    m.port_i.bind(c);
  }
};


int sc_main(int argc, char **argv)
{
  Top t("top");

  sc_start();
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
