#include "systemc.h"

class MyModule: public sc_module {
public:
  sc_in<bool> reset;
  sc_in<bool> reset2;

  sc_in<bool> async_reset;
  sc_in<bool> async_reset2;
  int x, y, z;
  int a, b, c;

  SC_HAS_PROCESS(MyModule);

  MyModule(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(my_cthread1);
    reset_signal_is(reset, true);

    SC_THREAD(my_cthread2);
    reset_signal_is(reset, true);
    reset_signal_is(reset2, true);

    SC_THREAD(my_cthread3);
    reset_signal_is(reset2, true);


    SC_THREAD(my_cthread4);
    async_reset_signal_is(async_reset, true);

    SC_THREAD(my_cthread5);
    async_reset_signal_is(async_reset, true);
    async_reset_signal_is(async_reset2, true);

    SC_THREAD(my_cthread6);
    async_reset_signal_is(async_reset2, true);
  }

  void my_cthread1()
  {
    /* some initialization */

    // Oh boy, this is so beautiful
    // if((this) -> reset . operator const bool &() ) {
    if(reset) {
      x = 42;
    }

    // First wait statement
    wait();

    /* computation and communication */
    int l = x * y;
    /* computation and communication */
  }

  void my_cthread2()
  {
    /* some initialization */
    if(reset) {
      y = 43;
    }

    // First wait statement
    wait();

    /* computation and communication */
    int l = x * y;
    /* computation and communication */
  }

  void my_cthread3()
  {
    /* some initialization */
    if(reset2) {
      z = 44;
      x = 32;
    }

    // First wait statement
    wait();

    /* computation and communication */
    int l = z * y;
    /* computation and communication */
  }

  void my_cthread4()
  {
    /* some initialization */

    // Oh boy, this is so beautiful
    // if((this) -> reset . operator const bool &() ) {
    if(async_reset) {
      a = 42;
    }

    // First wait statement
    wait();

    /* computation and communication */
    int l = a * b;
    /* computation and communication */
  }

  void my_cthread5()
  {
    /* some initialization */
    if(async_reset) {
      b = 43;
    }

    // First wait statement
    wait();

    /* computation and communication */
    int l = a * b;
    /* computation and communication */
  }

  void my_cthread6()
  {
    /* some initialization */
    if(async_reset2) {
      c = 44;
      b = 33;
    }

    // First wait statement
    wait();

    /* computation and communication */
    int l = c * b;
    /* computation and communication */
  }
};

SC_MODULE(Top)
{
  MyModule mm;

  sc_signal<bool> a;
  sc_signal<bool> b;
  sc_signal<bool> c;
  sc_signal<bool> d;

  SC_CTOR(Top):
    mm("mm")
  { }

  void before_end_of_elaboration()
  {
    mm.reset.bind(a);
    mm.reset2.bind(b);
    mm.async_reset.bind(c);
    mm.async_reset2.bind(d);
  }
};


int sc_main(int argc, char **argv)
{
  Top t("top");

  sc_start();
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
